//our piano
Keyboard kbd => Gain g => dac;
0.3 => g.gain;

kbd.load(me.dir() + "../lib/piano");

//diatonic scale repeated, so we can make chord B3 - D4 - F4
["C3", "D3", "E3", "F3", "G3", "A3", "B3", 
"C4", "D4", "E4", "F4", "G4", "A4", "B4"] @=> string scale[];

// string to midi
fun int [] translate(string notes[]) {
    int ret[notes.cap()];
    
    for (0 => int i; i < notes.cap(); ++i) {
        notes[i] => Utils.ntom => ret[i];
    }
    return ret;
}

// play chords using the same construction
for (0 => int i; i < 7; ++i) {
    string chord[3];
    
    // 1 - 3 - 5 
    scale[i] => chord[0];
    scale[i + 2] => chord[1];
    scale[i + 4] => chord[2];
    
    chord => translate => kbd.play;
    1::second => now;
}


// make inversions so that notes stay in the same octave
for (0 => int i; i < 7; ++i) {
    string chord[3];
    
    // 1 - 3 - 5 
    scale[i % 7] => chord[0];
    scale[(i + 2) % 7] => chord[1];
    scale[(i + 4) % 7] => chord[2];
    
    chord => translate => kbd.play;
    1::second => now;
}
