// metronome.ck

// Some code to make a CLICK sound
SinOsc s =>ADSR e=>dac;
e.set(0.005::second, 0.005::second, 0.0,0.1::second);

// BEATS PER MINUTE
60 => float bpm;
60/bpm => float bs; //duration of each beat in seconds

// TIME DIVISION:
3 => int div;
div /=> bs;

// Prints our choices to the screen
<<<"BPM: ",bpm>>>;
<<<"Precision: ",div>>>;

for(0=> int i; i < 128; i++) {

    // Main division, HEAD of the time: louder
    if (i%div == 0){
      880=> s.freq;
      0.8=> s.gain;
      <<<1, " ---">>>;
    }

    // Time subdivisions
    else {
      440 => s.freq;
      0.5=> s.gain;
      <<< i%div + 1, " ." >>>;
    }

    // Play the CLICK and let time pass
    e.keyOn();
  	bs::second=>now;
  	e.keyOff();
}
